// @flow

const {createStore, combineReducers, applyMiddleware} = require('redux')
const {makeActionsAndActionCreatorsForThings, makeNormalizedReducer} = require("@cybernetex/redux-things")
const {createActionCreatorAndActionTypes, middleware: ajaxMiddleware} = require("@cybernetex/redux-ajax")
// import {createActionCreatorAndActionTypes, middleware as ajaxMiddleware} from '@cybernetex/redux-ajax'
import type {CallbackActions, AjaxClient} from '@cybernetex/redux-ajax'

const delay = ms => new Promise(yea => setTimeout(yea, ms));

type Thing = {
  id: string,
  lol: string,
}

async function fetchlol(id: string): Promise<Thing> {
  await delay(300)
  return {
    id: 'Thing::1',
    lol: 'cats'
  }
}
type $key = '[data] Get Thing'
const key: $key = '[data] Get Thing'
const thingsClient: AjaxClient<$key, Thing, Error, void> = createActionCreatorAndActionTypes(key)

// Create a "client" for the model
const things = makeActionsAndActionCreatorsForThings('thing')

// Create a reducer slice and a selector
const selectThingById = (state, id) => state.things.byId[id]
const rootReducer = combineReducers({
  things: combineReducers({
    byId: makeNormalizedReducer(things)
  })
})


const retrieveThingFlow = ({dispatch, getState}) => next => (action: CallbackActions<$key, Thing, Error, void>) => {
  next(action)

  if (!action.meta || action.meta.key !== key) {
    return
  }

  if (action.type === thingsClient.actionTypes.ON_REQUEST) {
    return console.log('Request Callback')
  }

  if (action.type === thingsClient.actionTypes.ON_SUCCESS) {
    const thing = action.response
    return dispatch(things.insert(thing.id, thing))
  }

  if (action.type === thingsClient.actionTypes.ON_ERROR) {
    return console.error('Something Explode: ' + action.error.message)
  }
}

const logger = () => next => action => {
  console.log(action.type)
  next(action)
}

const store = createStore(rootReducer, {}, applyMiddleware(retrieveThingFlow, ajaxMiddleware, logger))

// dispatch some actions against the store
store.dispatch(thingsClient.createAction(() => fetchlol('Thing::1')))
setTimeout(() => {
  console.log(selectThingById(store.getState(), 'Thing::1'))
}, 1000)

