// import {createStore} from 'redux'
// import {makeActionsAndActionCreatorsForThings, makeNormalizedReducer} from "@cybernetex/redux-things"
const {createStore, combineReducers, applyMiddleware} = require('redux')
const {makeActionsAndActionCreatorsForThings, makeNormalizedReducer} = require("@cybernetex/redux-things")
const {createActionTypes, apiRequest, ajaxMiddleware} = require("@cybernetex/redux-ajax")

const delay = ms => new Promise(yea => setTimeout(yea, ms));

async function fetchlol() {
  await delay(300)
  return {
    id: 'Thing::1',
    lol: 'cats'
  }
}

const {
  onRequest: GET_THING_REQUEST,
  onSuccess: GET_THING_SUCCESS,
  onError: GET_THING_ERROR,
} = createActionTypes('data', 'GET_THING')

const GET_THING = '[thing] GET'
const getThing = (id) => ({
  type: GET_THING,
  callApi: () => fetchlol(`/api/things/${id}`),
  meta: {
    onRequest: GET_THING_REQUEST,
    onSuccess: GET_THING_SUCCESS,
    onError: GET_THING_ERROR,
  }
})

// Create a "client" for the model
const things = makeActionsAndActionCreatorsForThings('thing')

// Create a reducer slice and a selector
const selectThingById = (state, id) => state.things.byId[id]
const rootReducer = combineReducers({
  things: combineReducers({
    byId: makeNormalizedReducer(things)
  })
})

const retrieveThingFlow = ({dispatch, getState}) => next => action => {
  next(action)
  if(action.type === GET_THING) {
    return dispatch(apiRequest(action.callApi, action.meta))
  } else if (action.type === GET_THING_SUCCESS) {
  const thing = action.response
    return dispatch(things.insert(thing.id, thing))
  }
}

const logger = () => next => action => {
  console.log(action.type)
  next(action)
}

const store = createStore(rootReducer, {}, applyMiddleware(retrieveThingFlow, ajaxMiddleware, logger))

// dispatch some actions against the store
store.dispatch(getThing('Thing::1'))
setTimeout(() => {
  console.log(selectThingById(store.getState(), 'Thing::1'))
}, 1000)

