// @flow

import axios from 'axios'
import type { AxiosPromise, AxiosXHRConfigBase, AxiosXHR, $AxiosError } from 'axios';
import {createActionCreatorAndActionTypes} from '../src'
import type {CallbackActions} from '../src'

type RequestModel = {
  lolol: string
}

type Model = {
  lol: string
}

type ErrorModel = {
  code: string,
  message: string
}

class CustomError extends Error {
  data: ErrorModel

  constructor(data: ErrorModel) {
    super()
    this.data = data
  }
}


type ApiResponse = AxiosXHR<mixed, Model>
type ApiErrorResponse = $AxiosError<mixed, ErrorModel>
type Meta = { id: string }

type GET_LOL = 'GET_LOL'
const key: GET_LOL = 'GET_LOL'

const thing = createActionCreatorAndActionTypes<GET_LOL, ApiResponse, ApiErrorResponse, Meta>(key)
const config: AxiosXHRConfigBase<mixed, Model> = {}

thing.createAction(() => axios.get('lol', config), {id: 'lol'})
// thing.onRequest()

type LolActions = CallbackActions<GET_LOL, ApiResponse, ApiErrorResponse, Meta>
const getLolMiddleware = (next: LolActions => mixed) => (action: LolActions) => {
  next(action)

  if (action.meta && action.meta.key !== key) {
    return
  }

  if (action.type === thing.actionTypes.ON_SUCCESS) {
    const payload = action.response.data
    return
  }

  if (action.type === thing.actionTypes.ON_REQUEST) {
    return console.log('requested ' + action.meta.extras.id)
  }

  if (action.type === thing.actionTypes.ON_ERROR) {
    if (!action.error.response) {
      throw new Error('Unhandled Error!!!')
    }

    throw new CustomError(action.error.response.data)
  }
}

// const config2: AxiosXHRConfigBase<RequestModel, Model> = {}
// const action2 = thing.createAction(
//   () => axios.post('test', {
//       lolol: 'hello'
//     }, config2)
//   }
// )

