'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

//      






var API_REQUEST = '[@package/redux-things] API_REQUEST';
var ON_REQUEST = '[@package/redux-things] ON_REQUEST';
var ON_SUCCESS = '[@package/redux-things] ON_SUCCESS';
var ON_ERROR = '[@package/redux-things] ON_ERROR';











































function createActionCreatorAndActionTypes(key)









{
  var onRequest = function onRequest(meta) {
    return {
      type: ON_REQUEST,
      meta: {
        key: key,
        extras: meta } };


  };

  var onSuccess = function onSuccess(response, meta) {
    var action = {
      type: ON_SUCCESS,
      response: response,
      meta: {
        key: key,
        extras: meta } };


    return action;
  };

  var onError = function onError(error, meta) {return {
      type: ON_ERROR,
      error: error,
      meta: {
        key: key,
        extras: meta } };};



  var createAction = function createAction(thunk, meta) {return {
      type: API_REQUEST,
      thunk: thunk,
      meta: {
        key: key,
        onSuccess: onSuccess,
        onRequest: onRequest,
        onError: onError,
        extras: meta } };};



  return {
    actionTypes: {
      ON_REQUEST: ON_REQUEST,
      ON_SUCCESS: ON_SUCCESS,
      ON_ERROR: ON_ERROR },

    onRequest: onRequest,
    onSuccess: onSuccess,
    onError: onError,
    createAction: createAction };

}



var middleware = function middleware(_ref) {var dispatch = _ref.dispatch;return (
    function (next) {return (
        function (action) {
          next(action);

          if (action.type === API_REQUEST) {var

            meta =

            action.meta,thunk = action.thunk;var


            onRequest =



            meta.onRequest,onSuccess = meta.onSuccess,onError = meta.onError,extras = meta.extras;

            if (onRequest) {
              dispatch(onRequest(extras));
            }

            thunk().
            then(function (response) {
              if (!onSuccess) return;
              dispatch(onSuccess(response, meta));
            })["catch"](
            function (error) {
              if (!onError) return console.warn("Unhandled AJAX error: ".concat(error.message));
              dispatch(onError(error, meta));
            });
          }
        });});};

exports.API_REQUEST = API_REQUEST;
exports.ON_ERROR = ON_ERROR;
exports.ON_REQUEST = ON_REQUEST;
exports.ON_SUCCESS = ON_SUCCESS;
exports.createActionCreatorAndActionTypes = createActionCreatorAndActionTypes;
exports.middleware = middleware;
