// flow-typed signature: 5c90258393994e3fe1964ea213cf5c36
// flow-typed version: <<STUB>>/@cybernetex/redux-ajax_v0.2.1/flow_v0.106.3

declare module '@cybernetex/redux-ajax' {

  declare type $API_REQUEST = '[@package/redux-things] API_REQUEST'
  declare type $ON_REQUEST = '[@package/redux-things] ON_REQUEST'
  declare type $ON_SUCCESS = '[@package/redux-things] ON_SUCCESS'
  declare type $ON_ERROR = '[@package/redux-things] ON_ERROR'

  declare export var API_REQUEST: $API_REQUEST
  declare export var ON_REQUEST: $ON_REQUEST
  declare export var ON_SUCCESS: $ON_SUCCESS
  declare export var ON_ERROR: $ON_ERROR

  declare type Thunk<T> = void => Promise<T>

  declare export type Action<K, T, E, M> = {
    type: $API_REQUEST,
    thunk: Thunk<T>,
    meta: {
      key: K,
      extras: M,
      onRequest: M => RequestAction<K, M>,
      onSuccess: (response: T, meta: M) => SuccessAction<K, T, M>,
      onError: (error: E, meta: M) => ErrorAction<K, E, M>,
    }
  }

  declare export type RequestAction<K, M> = {
    type: $ON_REQUEST,
    meta: {
      extras: M,
      key: K,
    },
  }

  declare export type SuccessAction<K, T, M> = {
    type: $ON_SUCCESS,
    response: T,
    meta: {
      extras: M,
      key: K,
    },
  }

  declare export type ErrorAction<K, E, M> = {
    type: $ON_ERROR,
    error: E,
    meta: {
      extras: M,
      key: K,
    },
  }

  declare export type CallbackActions<K, T, E, M> = RequestAction<K, M> | SuccessAction<K, T, M> | ErrorAction<K, E, M>

  declare export type AjaxClient<K, T, E, M> = {
    key: K,
    actionTypes: {
      ON_REQUEST: $ON_REQUEST,
      ON_SUCCESS: $ON_SUCCESS,
      ON_ERROR: $ON_ERROR,
    },
    onRequest: (meta: M) => RequestAction<K, M>,
    onSuccess: (response: T, meta: M) => SuccessAction<K, T, M>,
    onError: (error: E, meta: M) => ErrorAction<K, E, M>,
    createAction: (thunk: Thunk<T>, meta: M) => Action<K, T, E, M>
  }

  declare export function createActionCreatorAndActionTypes<K, T, E, M>(key: K): {
    key: K,
    actionTypes: {
      ON_REQUEST: $ON_REQUEST,
      ON_SUCCESS: $ON_SUCCESS,
      ON_ERROR: $ON_ERROR,
    },
    onRequest: (meta: M) => RequestAction<K, M>,
    onSuccess: (response: T, meta: M) => SuccessAction<K, T, M>,
    onError: (error: E, meta: M) => ErrorAction<K, E, M>,
    createAction: (thunk: Thunk<T>, meta: M) => Action<K, T, E, M>
  }

  declare type Dispatch = CallbackActions<mixed, mixed, mixed, mixed> => mixed

  declare export function middleware(params: {dispatch: Dispatch}): mixed
}
